﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using LxS_Library;
using System.Net;
using System.Drawing.Drawing2D;
using System.IO;



namespace LxS_GUI
{
    public partial class MainForm : Form
    {
        #region [ Members ]

        LxS_Device lxs = null;
        private UInt16[] z_pts = null;
        private UInt16[] x_pts = null;
        private Boolean do_update = true;
        private int trig_cnt = 0;

        private UInt16 last_scan_nr = 0;
        private UInt16 last_scan_nr_x = 0;
        private UInt16 last_scan_nr_z = 0;
        private UInt32 last_enc_val = 0;
        private UInt32 scan_number_error = 0;
        private UInt32 scan_number_ok = 0;

        private List<String> les_list = new List<String>();
        private Boolean do_update_les = true;

        private List<String> lrs_list = new List<String>();
        private Boolean do_update_lrs = true;

        #endregion

        #region [ Helper ]

        private void AddLog(String msg)
        {
            if (this.lst_1.InvokeRequired)
            {
                this.lst_1.Invoke(new EventHandler(delegate
                {
                    this.lst_1.Items.Add(msg);
                    this.lst_1.SelectedIndex = this.lst_1.Items.Count - 1;
                }));
            }
            else
            {
                this.lst_1.Items.Add(msg);
                this.lst_1.SelectedIndex = this.lst_1.Items.Count - 1;
            }
        }

        private void tim_1_Tick(object sender, EventArgs e)
        {
            this.tim_1.Enabled = false;
            if (this.do_update)
            {
                this.do_update = false;
                this.Invalidate();
            }
            this.lbl_scan_lps.Text = this.last_scan_nr.ToString();
            this.lbl_encoder_lps.Text = this.last_enc_val.ToString();
            this.lbl_scan_les.Text = this.last_scan_nr.ToString();
            this.lbl_encoder_les.Text = this.last_enc_val.ToString();
            this.lbl_scan_lrs.Text = this.last_scan_nr.ToString();
            this.lbl_encoder_lrs.Text = this.last_enc_val.ToString();
            this.lbl_scan_ok.Text = this.scan_number_ok.ToString();
            this.lbl_scan_err.Text = this.scan_number_error.ToString();

            if (this.do_update_les)
            {
                try
                {
                    this.lst_les_data.Items.Clear();
                    foreach (String s in this.les_list)
                    {
                        this.lst_les_data.Items.Add(s);
                    }
                }
                catch { }
                this.do_update_les = false;
            }

            if (this.do_update_lrs)
            {
                try
                {
                    this.lst_lrs_data.Items.Clear();
                    foreach (String s in this.lrs_list)
                    {
                        this.lst_lrs_data.Items.Add(s);
                    }
                }
                catch { }
                this.do_update_lrs = false;
            }

            this.tim_1.Enabled = true;
        }

        private void tim_2_Tick(object sender, EventArgs e)
        {
            this.btn_trigger_Click(sender, null);
        }

        // Die Methode wird überschrieben, um die Punkte der LPS auf der PictureBox zu zeichnen
        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            int scale_x = (chb_0.Checked) ? (-50) : (-20);
            int scale_z = (chb_0.Checked) ? (200) : (20);
            int offset_x = 200;
            int offset_z = 0;

            Bitmap bmp = new Bitmap(400, 430);
            Graphics g = Graphics.FromImage(bmp);
            Pen pn = new Pen(Color.Red, (float)1.0);
            Pen pm = new Pen(Color.DarkGray, (float)1.0);
            Pen pb = new Pen(Color.DarkBlue, (float)1.0);
            Pen pl = new Pen(Color.Gray, (float)1.0);
            Point p;
            g.Clear(Color.White);
            if (this.chb_2.Checked)
            {
                for (int i = 0; i < 420; i += 10)
                {
                    g.DrawLine(pm, 10, i, 390, i);
                    g.DrawLine(pm, i, 10, i, 420);
                }
                g.DrawRectangle(pl, 10, 10, 380, 410);
                if (this.chb_0.Checked)
                {
                    g.DrawRectangle(pb, 70, 110, 240, 220);
                }
                if ((this.z_pts != null))
                {
                    int new_x = z_pts.Length + 10 + (this.chb_0.Checked ? 60 : 0);  // Die X Position wird errechnet
                    for (int i = 0; i < this.z_pts.Length; i++)
                    {
                        p = new Point((Int16)new_x--, (UInt16)z_pts[i]);
                        p.Y = p.Y / scale_z + offset_z;         // Skallierung und Offset für Y
                        g.DrawRectangle(pn, p.X, p.Y, 1, 1);    // Punkt zeichnen
                    }
                }
            }
            else
            {
                g.DrawLine(pm, 160, 100, 240, 100);
                g.DrawLine(pm, 160, 100, 45, 420);
                g.DrawLine(pm, 240, 100, 355, 420);

                g.DrawLine(pm, 200, 100, 200, 420);
                g.DrawLine(pm, 180, 100, 123, 420);
                g.DrawLine(pm, 220, 100, 277, 420);

                g.DrawLine(pm, 143, 150, 256, 150);
                g.DrawLine(pm, 125, 200, 274, 200);
                g.DrawLine(pm, 107, 250, 293, 250);
                g.DrawLine(pm, 88, 300, 311, 300);
                g.DrawLine(pm, 70, 350, 330, 350);
                g.DrawLine(pm, 52, 400, 348, 400);

                if (this.chb_0.Checked)
                {
                    g.DrawLine(pb, 57, 317, 343, 317);
                    g.DrawLine(pb, 148, 100, 252, 100);
                    g.DrawLine(pb, 148, 100, 57, 317);
                    g.DrawLine(pb, 252, 100, 343, 317);
                }
                g.DrawRectangle(pl, 10, 10, 380, 410);

                if ((this.z_pts != null) && (this.x_pts != null))
                {
                    for (int i = 0; i < this.z_pts.Length; i++)
                    {
                        p = new Point((Int16)x_pts[i], (UInt16)z_pts[i]);
                        p.X = p.X / (scale_x) + offset_x;       // Skallierung und Offset für X
                        p.Y = p.Y / scale_z + offset_z;         // Skallierung und Offset für Y
                        g.DrawRectangle(pn, p.X, p.Y, 1, 1);    // Punkt zeichnen
                    }
                }
            }
            g.Flush();
            pb.Dispose(); pn.Dispose(); pm.Dispose(); pl.Dispose(); g.Dispose();
            this.pic_1.Image = bmp;
        }

        #endregion

        #region [ Constructor & Destructor ]
        
        public MainForm()
        {
            InitializeComponent();
            // nur für interne Testzwecke
            // für Kunde nicht relevant, deswegen ausgeblendet.
            lbl_11.Visible = false;
            lbl_12.Visible = false;
            lbl_scan_err.Visible = false;
            lbl_scan_ok.Visible = false;
            btn_scan_err_rst.Visible = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetStyle(ControlStyles.OptimizedDoubleBuffer, true);
            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            SetStyle(ControlStyles.UserPaint, true);
        }

        #endregion

        #region [ Events ]

        private void Lxs_Handler(object sender, LxS_EventArgs e)
        {
            this.last_scan_nr = e.ScanNumber;
            this.last_enc_val = e.EncoderValue;

            UInt16[] tmp = e.Data;
            if (this.chb_1.Checked)
            {
                tmp = new UInt16[e.Data.Length];
                UInt16 end = (UInt16)(e.Data.Length - 1);
                UInt16 p1 = 0;
                UInt16 p2 = 0;
                UInt16 p3 = 0;
                UInt16 tm = 0;
                tmp[0] = e.Data[0];
                tmp[end] = e.Data[end];
                for (int i = 1; i < end; i++)
                {
                    p1 = e.Data[(i - 1)];
                    p2 = e.Data[i];
                    p3 = e.Data[(i + 1)];
                    if (p1 > p2) { tm = p1; p1 = p2; p2 = tm; }
                    if (p3 < p1) { p2 = p1; } else { if (p3 < p2) { p2 = p3; } }
                    tmp[i] = p2;
                }
            }

            if ((e.Command == LxS_Cmd.X_COORDINATES) || (e.Command == LxS_Cmd.ACK_X_COORDINATES))
            {
                x_pts = tmp;
                this.last_scan_nr_x = this.last_scan_nr;
                if (this.last_scan_nr_x != this.last_scan_nr_z)
                {
                    this.scan_number_error++;
                }
                else
                {
                    this.scan_number_ok++;
                    this.do_update = true;
                }
            }
            else if ((e.Command == LxS_Cmd.Z_COORDINATES) || (e.Command == LxS_Cmd.ACK_Z_COORDINATES))
            {
                z_pts = tmp;
                this.last_scan_nr_z = this.last_scan_nr;
            }
            else if (e.Command == LxS_Cmd.XZ_HIGH_DATA)
            {
                UInt16[] z_tmp = new UInt16[240];
                UInt16[] x_tmp = new UInt16[240];
                for (int i = 0; i < 240; i++)
                {
                    z_tmp[i] = e.Data[i];
                    x_tmp[i] = e.Data[240 + i];
                }
                z_pts = z_tmp;
                x_pts = x_tmp;
                this.do_update = true;
            }
            else
            {
                if ((e.Command == LxS_Cmd.DATA_FIELD))
                {
                    if (!this.do_update_lrs)
                    {
                        try
                        {
                            LRS_Adapter lrs = new LRS_Adapter(e);
                            List<String> lst = new List<String>();

                            lst.Add("LRS Data Adapter: OK");

                            lst.Add("Inspection Task:" + lrs.InspectionTask.ToString());
                            lst.Add("Results:" + lrs.Results.ToString());

                            UInt16[] hts = lrs.Hits;
                            for (int i = 0; i < 16; i++)
                            {
                                lst.Add("Hits " + i.ToString() + ":" + hts[i].ToString());
                            }

                            UInt16[] lgc = lrs.LogicalDepth;
                            for (int i = 0; i < 4; i++)
                            {
                                lst.Add("Logics " + i.ToString() + ":" + lgc[i].ToString());
                            }

                            lst.Add("AND Column:" + lrs.LogicalAnalysis.ToString());
                            lst.Add("Outputs:" + lrs.Outputs.ToString());
                            lst.Add("Inputs:" + lrs.Inputs.ToString());

                            this.lrs_list = lst;
                            this.do_update_lrs = true;
                        }
                        catch
                        {
                            this.lrs_list.Clear();
                            this.lrs_list.Add("LRS Data Adapter: NO LRS DATA FOUND !!!");
                            this.do_update_lrs = true;
                        }
                    }

                    if (!this.do_update_les)
                    {
                        try
                        {
                            LES_Adapter les = new LES_Adapter(e);
                            List<String> lst = new List<String>();

                            lst.Add("LES Data Adapter: OK");

                            lst.Add("Inspection Task:" + les.InspectionTask.ToString());
                            lst.Add("Results:" + les.Results.ToString());

                            UInt16[] hts = les.Hits;
                            for (int i = 0; i < 8; i++)
                            {
                                lst.Add("Hits " + i.ToString() + ":" + hts[i].ToString());
                            }

                            UInt16[] lgc = les.LogicalResults;
                            for (int i = 0; i < 4; i++)
                            {
                                lst.Add("Logics " + i.ToString() + ":" + lgc[i].ToString());
                            }

                            LES_EAW[] eaws = les.EAWs;
                            for (int i = 0; i < 4; i++)
                            {
                                lst.Add("EAW " + i.ToString() + ":" + eaws[i].CurrentHits.ToString());
                            }

                            this.les_list = lst;
                            this.do_update_les = true;
                        }
                        catch
                        {
                            this.les_list.Clear();
                            this.les_list.Add("LES Data Adapter: NO LES DATA FOUND !!!");
                            this.do_update_les = true;
                        }
                    }
                }
            }
        }
        
        #endregion

        #region [ Buttons & Controls ]

        private void btn_connection_Click(object sender, EventArgs e)
        {
            this.x_pts = null;
            this.z_pts = null;
            if (this.btn_connection.Text.Equals("Connect"))
            {// Verbinden
                try
                {
                    this.AddLog("Connect to " + this.txt_ip.Text + ":" + this.txt_lport.Text);
                    this.lxs = new LxS_Device(int.Parse(txt_pport.Text));
                    this.lxs.DeviceIP = new IPEndPoint(IPAddress.Parse(this.txt_ip.Text), int.Parse(this.txt_lport.Text));
                    this.lxs.TimeOut = 1000;
                    this.lxs.DataHandler += new LxS_Event(this.Lxs_Handler);

                    int cnt = 0;
                    while (!this.lxs.Connect(this.chb_0.Checked))
                    {
                        this.lxs.Disconnect();
                        System.Threading.Thread.Sleep(100);
                        this.AddLog("No Connection ... (" + (++cnt).ToString() + ")");
                        Application.DoEvents();
                        if (cnt > 2)
                        {
                            this.AddLog("Could not establish Connection");
                            return;
                        }
                    }

                    this.lxs.SetSensorMode(LxS_Mode.COMMAND);
                    this.AddLog("Connected");
                    this.AddLog("Type:" + lxs.GetDeviceType().ToString());
                    LxS_Mode m = lxs.GetSensorMode();
                    this.AddLog("Mode:" + m.ToString());
                    this.btn_connection.Text = "Disconnect";
                    if (m.Equals(LxS_Mode.COMMAND))
                    {
                        this.grp_4.Enabled = true;
                        this.btn_mode.Text = "Mode: COMMAND";
                    }
                    else
                    {
                        this.grp_4.Enabled = false;
                        this.btn_mode.Text = "Mode: MEASURE";
                    }
                    this.txt_ip.Enabled = false;
                    this.txt_lport.Enabled = false;
                    this.txt_pport.Enabled = false;
                    this.chb_0.Enabled = false;
                    this.grp_2.Enabled = true;
                }
                catch (Exception ex)
                {
                    this.AddLog("Exception: " + ex.Message);
                    this.txt_ip.Enabled = true;
                    this.txt_lport.Enabled = true;
                    this.txt_pport.Enabled = true;
                    this.chb_0.Enabled = true;
                    this.grp_2.Enabled = false;
                    this.lxs.Disconnect();
                    this.lxs.Dispose();
                    try { GC.SuppressFinalize(lxs); }
                    catch { }
                    this.lxs = null;
                    this.btn_connection.Text = "Connect";                    
                    return;
                }
            }
            else
            {// Trennen
                this.tim_2.Enabled = false;
                this.txt_ip.Enabled = true;
                this.txt_lport.Enabled = true;
                this.txt_pport.Enabled = true;
                this.chb_0.Enabled = true;
                this.grp_2.Enabled = false;
                this.lxs.Disconnect();
                this.lxs.Dispose();
                try { GC.SuppressFinalize(lxs); }
                catch { }
                this.lxs = null;
                this.AddLog("Disconnected");
                this.btn_connection.Text = "Connect";
            }
        }

        private void btn_mode_Click(object sender, EventArgs e)
        {
            if (this.btn_mode.Text.Equals("Mode: COMMAND"))
            {// zu Messmodus umschalten
                this.AddLog("Switch to Measure-Mode");
                Boolean ret = this.lxs.SetSensorMode(LxS_Mode.MEASURE);
                this.AddLog("Return: " + ret.ToString());
                this.grp_4.Enabled = false;
                this.btn_mode.Text = "Mode: MEASURE";
            }
            else
            {// zu Kommandomodus umschalten
                this.AddLog("Switch to Command-Mode");
                Boolean ret = this.lxs.SetSensorMode(LxS_Mode.COMMAND);
                this.AddLog("Return: " + ret.ToString());
                this.grp_4.Enabled = true;
                this.btn_mode.Text = "Mode: COMMAND";
            }
        }

        private void btn_laser_Click(object sender, EventArgs e)
        {
            if (this.btn_laser.Text.Equals("Laser: ON"))
            {// Laser ausschalten
                this.AddLog("Turn Laser off");
                Boolean ret = this.lxs.SetLaserGate(false);
                this.AddLog("Return: " + ret.ToString());
                this.btn_laser.Text = "Laser: OFF";
            }
            else
            {// Laser einschalten
                this.AddLog("Turn Laser on");
                Boolean ret = this.lxs.SetLaserGate(true);
                this.AddLog("Return: " + ret.ToString());
                this.btn_laser.Text = "Laser: ON";
            }
        }

        private void btn_activation_Click(object sender, EventArgs e)
        {
            if (this.btn_activation.Text.Equals("Activation: ON"))
            {// Laser ausschalten
                this.AddLog("Turn Sensor off");
                Boolean ret = this.lxs.SetActivation(false);
                this.AddLog("Return: " + ret.ToString());
                this.btn_activation.Text = "Activation: OFF";
            }
            else
            {// Laser einschalten
                this.AddLog("Turn Sensor on");
                Boolean ret = this.lxs.SetActivation(true);
                this.AddLog("Return: " + ret.ToString());
                this.btn_activation.Text = "Activation: ON";
            }
        }

        private void btn_trigger_Click(object sender, EventArgs e)
        {
            int numOfTlgWait = 0;
            if (this.chb_0.Checked)
                numOfTlgWait = 1;   // Hi Connect
            else
                numOfTlgWait = 2;

            this.AddLog("Ethernet Trigger: " + (this.trig_cnt++).ToString());
            for (int i = 0; i < 50; i++)
            {
                this.lxs.EthernetTrigger(true, numOfTlgWait);
            }
        }

        private void btn_get_task_Click(object sender, EventArgs e)
        {
            UInt16 tsk = this.lxs.GetInspectionTask();
            this.AddLog("GetInspectionTask(" + tsk.ToString() + ")");
            if (tsk > 15)
            {
                this.txt_task.Text = "ERROR";
            }
            else
            {
                this.txt_task.Text = tsk.ToString();
            }
        }

        private void btn_set_task_Click(object sender, EventArgs e)
        {
            try
            {
                UInt16 tsk = UInt16.Parse(this.txt_task.Text);
                this.AddLog("SetInspectionTask(" + tsk.ToString() + ")");
                Boolean ret = this.lxs.SetInspectionTask(tsk, false);
                this.AddLog("Return: " + ret.ToString());
            }
            catch
            {
                this.AddLog("SetInspectionTask failed");
            }
        }

        private void btn_auto_trigger_Click(object sender, EventArgs e)
        {
            if (this.btn_auto_trigger.Text.Equals("Start Auto-Trigger"))
            {
                this.AddLog("Start Auto-Trigger");
                this.txt_timer.Enabled = false;
                this.tim_2.Interval = int.Parse(this.txt_timer.Text);
                this.tim_2.Enabled = true;
                this.btn_auto_trigger.Text = "Stop Auto-Trigger";
            }
            else
            {
                this.AddLog("Stop Auto-Trigger");
                this.tim_2.Enabled = false;
                this.txt_timer.Enabled = true;
                this.btn_auto_trigger.Text = "Start Auto-Trigger";
            }
        }

        private void btn_clear_Click(object sender, EventArgs e)
        {
            this.lst_1.Items.Clear();
        }

        private void btn_setbt_Click(object sender, EventArgs e)
        {
            int val;
            if (this.hscr_bt.Value == 2)
            {
                val = 739;
            }
            else
            {
                val = ((this.hscr_bt.Value - 3) * 328) + 973;
            }

            LxS_Parameter p = this.lxs.GetSingleTaskParameter(3006);
            if (p == null)
            {
                this.AddLog("Error: GetSingleTaskParameter only");
                this.AddLog("in Firmware V01.40 and higher");
            }
            else
            {
                UInt16[] v = p.GetField();
                this.AddLog("Set Exposure Time to " + (val / 10.0).ToString() + "µs");
                this.AddLog("Old Value:" + (v[0] / 10.0).ToString() + "µs");
                val = ((val > p.MAXIMUM) ? ((int)p.MAXIMUM) : (val));
                val = ((val < p.MINIMUM) ? ((int)p.MINIMUM) : (val));
                v[0] = ((UInt16)(val));
                if ((p.SetField(v)) && (this.lxs.SetSingleTaskParameter(p, false)))
                {
                    p = this.lxs.GetSingleTaskParameter(3006);
                    v = p.GetField();
                    this.AddLog("New Value:" + (v[0] / 10.0).ToString() + "µs");
                    if (v[0] <= 739)
                    {
                        this.hscr_bt.Value = 2;
                    }
                    else
                    {
                        if (v[0] >= 973)
                        {
                            this.hscr_bt.Value = (int)((v[0]-973) / 328) + 3;
                        }
                    }
                }
                else
                {
                    this.AddLog("SetField failed");
                }
            }
        }

        private void btn_info_Click(object sender, EventArgs e)
        {
            // AN DER STELLE WERDEN VERSCHIEDENE TESTS AUSGEFÜHRT !!!
            this.AddLog("LxS Information");
            this.AddLog("Lib Version: " + this.lxs.Version);
            this.AddLog("LxS Device: " + this.lxs.GetDeviceType().ToString());
            LxS_Parameter param = null;
            UInt16[] value = null;

            // Tasknummer
            param = this.lxs.GetSingleTaskParameter(3000);
            if (param == null)
            {
                this.AddLog("Error: use sensor command only");
                this.AddLog("with Firmware V01.40 and higher"); 
            }
            else
            {
                value = param.GetField();
                this.AddLog("Tasknummer: " + value[0].ToString());

                // Taskname
                param = this.lxs.GetSingleTaskParameter(3001);
                value = param.GetField();
                String tn = "";
                foreach (UInt16 u in value) { tn += (Char)(u); }
                this.AddLog("Taskname: " + tn);

                // Betriebsart
                param = this.lxs.GetSingleTaskParameter(3002);
                value = param.GetField();
                this.AddLog(((value[0] == 0) ? ("Mode: Freerunning") : ("Mode: Triggerd")));

                // Aktivierungsquelle
                param = this.lxs.GetSingleTaskParameter(3003);
                value = param.GetField();
                this.AddLog(((value[0] == 0) ? ("Activation: Permanent") : ("Activation: External")));

                // Kaskadierausgang
                param = this.lxs.GetSingleTaskParameter(3004);
                value = param.GetField();
                this.AddLog(((value[0] == 0) ? ("CascadeOut: Low") : ("CascadeOut: Activated")));

                // Belichtungsmodus
                param = this.lxs.GetSingleTaskParameter(3005);
                value = param.GetField();
                String bm = "";
                switch (value[0])
                {
                    case 0: { bm = "Normal"; break; }
                    case 1: { bm = "Bright Objects"; break; }
                    case 2: { bm = "Dark Objects"; break; }
                    case 3: { bm = "Normal to Bright"; break; }
                    case 4: { bm = "Manual"; break; }
                }
                this.AddLog("Exposure: " + bm);

                // Manueller Belichtungswert
                param = this.lxs.GetSingleTaskParameter(3006);
                value = param.GetField();
                this.AddLog("Exposure Time: " + (value[0] / 10.0).ToString() + "µs");

                // FOV X
                param = this.lxs.GetSingleTaskParameter(3007);
                value = param.GetField();
                this.AddLog("FOV X: " + value[0].ToString() + "; " + value[1].ToString());

                // FOV Z
                param = this.lxs.GetSingleTaskParameter(3008);
                value = param.GetField();
                this.AddLog("FOV Z: " + value[0].ToString() + "; " + value[1].ToString());
            }
        }

        private void chb_1_CheckedChanged(object sender, EventArgs e)
        {
            this.AddLog("Median Filter is: " + ((this.chb_1.Checked) ? ("ON") : ("OFF")));
            this.do_update = true;
        }

        private void chb_2_CheckedChanged(object sender, EventArgs e)
        {
            this.AddLog(((this.chb_2.Checked) ? ("Z-Points only") : ("XZ-Points")));
            this.do_update = true;
        }

        private void chb_0_CheckedChanged(object sender, EventArgs e)
        {
            this.x_pts = null;
            this.z_pts = null;
            this.do_update = true;
        }

        #endregion

        #region [ FOR TESTING ONLY ]


        private void btn_test1_Click(object sender, EventArgs e)
        {
            //// Test: ErrorNumber
            //StreamWriter sw = new StreamWriter("e:\\out2.txt");
            //for (UInt16 i = 100; i < 1417; i++)
            //{
            //    sw.WriteLine(i.ToString() + "\t" + this.lxs.GetErrorText(i));
            //}
            //sw.Flush();
            //sw.Close();
            LxS_Parameter p2 = this.lxs.GetSingleUserParameter(2011);
            if (p2 == null)
            {
                this.AddLog("Error: median filter only");
                this.AddLog("in Firmware V01.40 and higher");
            }
            else
            {
                this.AddLog("T:" + (p2.GetField())[0].ToString());
            }
        }

        private void btn_test2_Click(object sender, EventArgs e)
        {
            LxS_Parameter p2 = this.lxs.GetSingleUserParameter(2011);
            if (p2 == null)
            {
                this.AddLog("Error: median filter only");
                this.AddLog("in Firmware V01.40 and higher");
            }
            else
            {
                UInt16[] val = p2.GetField();
                val[0] = 1;
                p2.SetField(val);
                this.lxs.SetSingleUserParameter(p2, false);
            }
        }

        private void btn_test3_Click(object sender, EventArgs e)
        {
            LxS_Parameter p2 = this.lxs.GetSingleUserParameter(2011);
            if (p2 == null)
            {
                this.AddLog("Error: median filter only");
                this.AddLog("in Firmware V01.40 and higher");
            }
            else
            {
                UInt16[] val = p2.GetField();
                val[0] = 0;
                p2.SetField(val);
                this.lxs.SetSingleUserParameter(p2, false);
            }
        }


        #endregion

        private void btnTestTeach_Click(object sender, EventArgs e)
        {
            if (lxs.GetSensorMode() == LxS_Mode.COMMAND)
            {
                LxS_Type actDevType = this.lxs.GetDeviceType();
                if (actDevType == LxS_Type.LRS_36_6 || actDevType == LxS_Type.LRS_36_6_10 || actDevType == LxS_Type.LRS_36_PB)
                {
                        LxS_RawData data = this.lxs.ExecuteCommand(LxS_Cmd.EXECUTE_AREA_SCAN_BASIC_TEACH, new byte[4]{20,0,2,0}); // Offset: 20mm, Sensitvity: 2 = medium
                        //            LxS_RawData data = this.lxs.ExecuteCommand(LxS_Cmd.EXECUTE_AREA_SCAN_ADVAN_TEACH, new byte[4]{0,0,0,0}); // wenn alle Param = 0 dann verwende Parameterwerte aus dem Displaymenue
                        //            LxS_RawData data = this.lxs.ExecuteCommand(LxS_Cmd.EXECUTE_TRACK_SCAN_TEACH, new byte[6]{0,0,0,0,0,0});
                        this.AddLog("Teach Area Scan Basic ausgelöst");
                        this.AddLog("Rückgabewert1: " + data.SData[0].ToString());
                        this.AddLog("Rückgabewert2: " + data.SData[1].ToString());
                }
                else
                {
                    this.AddLog("Teach nur bei LRS Typen !!!");
                }

            }
            else
            {
                this.AddLog("Teach nur im Kommandomodus auslösbar !!!");
            }
        }

        private void btnToggleOpMode_Click(object sender, EventArgs e)
        {
            if (lxs.GetSensorMode() == LxS_Mode.COMMAND)
            {
                LxS_Parameter param = this.lxs.GetSingleTaskParameter((UInt16)LxS_ParamName.OPERATION_MODE);
                UInt16[] data = param.GetField();
                if (data[0] > 0)
                    data[0] = 0;
                else
                    data[0] = 1;
                param.SetField(data);
                this.lxs.SetSingleTaskParameter(param, false);
            }
            else
            {
                this.AddLog("Betriebsart nur im Kommandomodus änderbar!!!");
            }
        }

        private void btn_scan_err_rst_Click(object sender, EventArgs e)
        {
            this.scan_number_error = 0;
            this.scan_number_ok = 0;
        }

        
        

        


    }
}
