function varargout = GUI_lxslib(varargin)
% GUI_LXSLIB MATLAB code for GUI_lxslib.fig
%      GUI_LXSLIB, by itself, creates a new GUI_LXSLIB or raises the existing
%      singleton*.
%
%      H = GUI_LXSLIB returns the handle to a new GUI_LXSLIB or the handle to
%      the existing singleton*.
%
%      GUI_LXSLIB('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI_LXSLIB.M with the given input arguments.
%
%      GUI_LXSLIB('Property','Value',...) creates a new GUI_LXSLIB or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI_lxslib_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_lxslib_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI_lxslib

% Last Modified by GUIDE v2.5 20-Feb-2012 17:30:22

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_lxslib_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_lxslib_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GUI_lxslib is made visible.
function GUI_lxslib_OpeningFcn(hObject, eventdata, handles, varargin)%#ok
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI_lxslib (see VARARGIN)

% Choose default command line output for GUI_lxslib
handles.output = hObject;

% UIWAIT makes GUI_lxslib wait for user response (see UIRESUME)
% uiwait(handles.hLxSlib);

handles.plot2D = plot(handles.axes1,...
                      zeros(1,376), zeros(1,376), '-r');

set(handles.axes1, 'XLim',[-3200 3200],'YLim', [1800 8200],...
                   'XTick',[-3000 -2000 -1000 0 1000 2000 3000],...
                   'XTickLabel', ['-300.0';'-200.0';'-100.0';'  0   ';'100.0 ';'200.0 ';'300.0 '],...
                   'YTick',[2000 3000 4000 5000 6000 7000 8000],...
                   'YTickLabel', ['200.0';'300.0';'400.0';'500.0';'600.0';'700.0';'800.0'],...
                   'XGrid', 'on', 'YGrid', 'on',...
                   'YDir', 'reverse',...
                   'XDir', 'reverse');
xlabel(handles.axes1,'X in mm');
ylabel(handles.axes1,'Z in mm');

set(handles.bgrpExposure, 'SelectionChangeFcn', @radioExposureSelection_Callback);
set(get(handles.bgrpExposure, 'children'), 'Enable', 'off');

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = GUI_lxslib_OutputFcn(hObject, eventdata, handles) %#ok
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pbtnConnect.
function pbtnConnect_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to pbtnConnect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

mode = get(handles.pbtnConnect, 'String');
switch mode
    case 'Connect'
        ip_address = get(handles.etxtIP, 'String');
        lxsPortNo = get(handles.etxtLXSPort, 'String');
        pcPortNo = get(handles.etxtPCPort, 'String');
        if ~isfield(handles, 'lxsDevice')
            handles.lxsDevice = LxS(ip_address, str2double(lxsPortNo), str2double(pcPortNo));
        end

        isConnected = handles.lxsDevice.connect;  
        if (isConnected)
            set(handles.etxtIP, 'Enable', 'off')
            set(handles.etxtLXSPort, 'Enable', 'off')
            set(handles.etxtPCPort, 'Enable', 'off') 
            set(handles.pbtnMode, 'Enable', 'on')
            set(handles.popupmenu1, 'Enable', 'on')
            
            set(handles.pbtnConnect, 'String', 'Disconnect');
            
            mode = handles.lxsDevice.getSensorMode();
            handles.lxsDevice.setCommandMode();

            insptask = handles.lxsDevice.getInspectionTask();
            set(handles.popupmenu1, 'Value', insptask+1);
            inspTaskName = handles.lxsDevice.getInspectionTaskName(insptask);
            set(handles.stxtTaskName, 'String', inspTaskName);
            
            % Read Exposure Mode of selected Inspeection Task from Sensor
            exposureMode = handles.lxsDevice.getSingleTaskParameter(3005);
            set(get(handles.bgrpExposure, 'children'), 'Enable', 'on');
            setExposureMode(handles, exposureMode);
            
            if exposureMode == 4                
                exposureTime = handles.lxsDevice.getSingleTaskParameter(3006);
                set(handles.pbtnSetManExpTime, 'String', num2str(exposureTime))
            end
            
            if mode == LxS_Library.LxS_Mode.COMMAND
                handles.lxsDevice.setCommandMode();
                set(handles.pbtnMode, 'String', 'Measurement');
                set(handles.pbtnConfigSensor, 'Enable', 'on')
            	set(handles.pbtnConfigFile, 'Enable', 'on')
            elseif mode == LxS_Library.LxS_Mode.MEASURE
                handles.lxsDevice.setMeasurementMode();
                set(handles.pbtnConfigSensor, 'Enable', 'off')
                set(handles.pbtnConfigFile, 'Enable', 'off')
                set(handles.pbtnMode, 'String', 'Command');
            end
            
            addlistener(handles.lxsDevice, 'DataSetReceived', @DataReceived_GUI_CB);
        else
            try %#ok
                handles.lxsDevice.deleteLxS;
            end
        end
    
    case 'Disconnect'
        try %#ok
            handles.lxsDevice.disconnect();
        end
        set(handles.etxtIP, 'Enable', 'on')
        set(handles.etxtLXSPort, 'Enable', 'on')
        set(handles.etxtPCPort, 'Enable', 'on') 
        set(handles.pbtnMode, 'Enable', 'off')
        set(handles.pbtnConfigSensor, 'Enable', 'off')
        set(handles.pbtnConfigFile, 'Enable', 'off')
        set(handles.popupmenu1, 'Enable', 'off')
        set(get(handles.bgrpExposure, 'children'), 'Enable', 'off');
        
        set(handles.pbtnConnect, 'String', 'Connect');
        isConnected = false;
end

handles.isConnected = isConnected;
guidata(hObject, handles);


function DataReceived_GUI_CB(source,eventData)  %#ok
    %disp(['GUI Scan Number: ' num2str(source.lpsScanNumber)])
    figurehandle = findall(0,'Type','figure'); 
    handles = guidata(figurehandle);
   
    set(handles.stxtProfileNumber, 'String',num2str(source.lpsScanNumber))
    set(handles.plot2D, 'XData', source.lpsXData)
    set(handles.plot2D, 'YData', source.lpsZData)
    
    


function etxtIP_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to etxtIP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of etxtIP as text
%        str2double(get(hObject,'String')) returns contents of etxtIP as a double


% --- Executes during object creation, after setting all properties.
function etxtIP_CreateFcn(hObject, eventdata, handles)%#ok
% hObject    handle to etxtIP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function etxtLXSPort_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to etxtLXSPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of etxtLXSPort as text
%        str2double(get(hObject,'String')) returns contents of etxtLXSPort as a double


% --- Executes during object creation, after setting all properties.
function etxtLXSPort_CreateFcn(hObject, eventdata, handles)%#ok
% hObject    handle to etxtLXSPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function etxtPCPort_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to etxtPCPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of etxtPCPort as text
%        str2double(get(hObject,'String')) returns contents of etxtPCPort as a double


% --- Executes during object creation, after setting all properties.
function etxtPCPort_CreateFcn(hObject, eventdata, handles)%#ok
% hObject    handle to etxtPCPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when user attempts to close hLxSlib.
function hLxSlib_CloseRequestFcn(hObject, eventdata, handles)%#ok
% hObject    handle to hLxSlib (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
if isfield(handles, 'lxsDevice')
    try %#ok
        handles.lxsDevice.disconnect();
        handles.lxsDevice.deleteLxS();
    end
end
delete(hObject);


% --- Executes on button press in pbntTrigger.
function pbntTrigger_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to pbntTrigger (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isfield(handles, 'lxsDevice')
    handles.lxsDevice.trigger;
end

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
if ~isfield(handles, 'lxsDevice')
    return
end

list = str2double(get(handles.popupmenu1, 'String'));
element = get(handles.popupmenu1, 'Value');
insptask = list(element);
mode = handles.lxsDevice.getSensorMode();
handles.lxsDevice.setCommandMode();
handles.lxsDevice.setInspectionTask(insptask);

% Read Name of selected Inspection Task from Sensor
inspTaskName = handles.lxsDevice.getInspectionTaskName(insptask);
set(handles.stxtTaskName, 'String', inspTaskName);

% Read Exposure Mode of selected Inspeection Task from Sensor
exposureMode = handles.lxsDevice.getSingleTaskParameter(3005);
setExposureMode(handles, exposureMode);

%set(handles.stxtTaskName, 'String', inspTaskName)

% ML 2011
% mode = mode.char;
% switch mode
%     case 'COMMAND'
%         handles.lxsDevice.setCommandMode();
%     case 'MEASURE'    
%         handles.lxsDevice.setMeasurementMode();
% end
if mode == LxS_Library.LxS_Mode.COMMAND
    handles.lxsDevice.setCommandMode();
elseif mode == LxS_Library.LxS_Mode.MEASURE
    handles.lxsDevice.setMeasurementMode();
end

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)%#ok
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pbtnMode.
function pbtnMode_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to pbtnMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of pbtnMode
if ~isfield(handles, 'lxsDevice')
    return
end

mode = get(handles.pbtnMode, 'String');
switch mode
    case 'Measurement'
        handles.lxsDevice.setMeasurementMode();
        set(handles.pbtnMode, 'String', 'Command');
        set(handles.pbtnConfigSensor, 'Enable', 'off')
        set(handles.pbtnConfigFile, 'Enable', 'off')
    case 'Command'    
        handles.lxsDevice.setCommandMode();
        set(handles.pbtnMode, 'String', 'Measurement');
        if handles.isConnected
            set(handles.pbtnConfigSensor, 'Enable', 'on')
            set(handles.pbtnConfigFile, 'Enable', 'on') 
        end
end

% --- Executes on button press in pbtnConfigSensor.
function pbtnConfigSensor_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to pbtnConfigSensor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ~isfield(handles, 'lxsDevice')
    return
end
[filename pathname filter] = uigetfile('*.xml', 'Configfile auswhlen');%#ok
if isempty(filename)
    return
end

file = fullfile(pathname, filename);
handles.lxsDevice.readConfigFromXMLSendToSensor(file)



% --- Executes on button press in pbtnConfigFile.
function pbtnConfigFile_Callback(hObject, eventdata, handles)%#ok
% hObject    handle to pbtnConfigFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if ~isfield(handles, 'lxsDevice')
    return
end

[filename pathname] = uiputfile('Config.xml', 'Save Sensor Configuration');
if isempty(filename)
    return
end
file = fullfile(pathname, filename);
handles.lxsDevice.readConfigFromSensorWriteToFile(file);

function radioExposureSelection_Callback(source, eventData)  %#ok
selectedButtonHandle = eventData.NewValue;

figurehandle = findall(0,'Type','figure'); 
handles = guidata(figurehandle);

sensorMode = handles.lxsDevice.getSensorMode();
handles.lxsDevice.setCommandMode();

insptask = handles.lxsDevice.getInspectionTask();
switch selectedButtonHandle
    case handles.rbtnNormal
        set(handles.pbtnSetManExpTime, 'Enable', 'off')
        handles.lxsDevice.setSingleTaskParameter(3005, 0, false)
    case handles.rbtnBright
        set(handles.pbtnSetManExpTime, 'Enable', 'off')
        handles.lxsDevice.setSingleTaskParameter(3005, 1, false)
    case handles.rbtnDark
        set(handles.pbtnSetManExpTime, 'Enable', 'off')
        handles.lxsDevice.setSingleTaskParameter(3005, 2, false)
    case handles.rbtnManual
        handles.lxsDevice.setSingleTaskParameter(3005, 4, false)
        exposureTime = handles.lxsDevice.getSingleTaskParameter(3006);
        set(handles.pbtnSetManExpTime, 'String', num2str(exposureTime))
        set(handles.pbtnSetManExpTime, 'Enable', 'on')
end

if sensorMode == LxS_Library.LxS_Mode.COMMAND
    handles.lxsDevice.setCommandMode();
elseif sensorMode == LxS_Library.LxS_Mode.MEASURE
    handles.lxsDevice.setMeasurementMode();
end

   
function setExposureMode(handles, exposureMode)
switch exposureMode
    case 0
        set(handles.rbtnNormal, 'Value', 1)
        set(handles.pbtnSetManExpTime, 'Enable', 'off')
    case 1
        set(handles.rbtnBright, 'Value', 1)
        set(handles.pbtnSetManExpTime, 'Enable', 'off')
    case 2
        set(handles.rbtnDark, 'Value', 1)
        set(handles.pbtnSetManExpTime, 'Enable', 'off')
    case 4
        set(handles.rbtnManual, 'Value', 1)
        set(handles.pbtnSetManExpTime, 'Enable', 'on')
end


% --- Executes on slider movement.
function slExpTime_Callback(hObject, eventdata, handles) %#ok
% hObject    handle to slExpTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
expTime = get(hObject, 'Value');
set(handles.pbtnSetManExpTime, 'String', num2str(expTime))

% --- Executes during object creation, after setting all properties.
function slExpTime_CreateFcn(hObject, eventdata, handles)  %#ok
% hObject    handle to slExpTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
set(hObject, 'Max', 13109);
set(hObject, 'Min', 973);
set(hObject, 'SliderStep', [1/(13109-973) 1/(13109-973)]);


% --- Executes on button press in pbtnSetManExpTime.
function pbtnSetManExpTime_Callback(hObject, eventdata, handles)  %#ok
% hObject    handle to pbtnSetManExpTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
expTime = str2double(get(handles.pbtnSetManExpTime, 'String'));

sensorMode = handles.lxsDevice.getSensorMode();
handles.lxsDevice.setCommandMode();
handles.lxsDevice.setSingleTaskParameter(3006, expTime, false)
if sensorMode == LxS_Library.LxS_Mode.COMMAND
    handles.lxsDevice.setCommandMode();
elseif sensorMode == LxS_Library.LxS_Mode.MEASURE
    handles.lxsDevice.setMeasurementMode();
end
